//------------------------------------------------------------------------------
//
//  npglut.c
//  ANTZ application based on npe
//
//  Created by Shane Saxon on 2/19/10.
//  Copyright Saxon Digital 2010. All rights reserved.
//
//------------------------------------------------------------------------------

#include "npglut.h"


#include "../npio.h"

#include "npgl.h"
#include "npkey.h"


#define kWindowWidth 640
#define kWindowHeight 480
#define kWindowPositionX 50
#define kWindowPositionY 50


void npGlutInitGL();
void npGlutDrawGLScene(void);
void npGlutResizeGLScene(int Width, int Height);

void npGlutKeyDown (unsigned char key, int x, int y);
void npGlutKeyUp (unsigned char key, int x, int y);
void npGlutKeyDownSpecial (int key, int x, int y);
void npGlutKeyUpSpecial (int key, int x, int y);


//------------------------------------------------------------------------------
void npInitGlut (int argc, char **argv, void* dataRef)
{
	glutInit (&argc, argv);

	glutInitDisplayMode (GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);		//GLUT_RGB
	glutInitWindowPosition (kWindowPositionX, kWindowPositionY);
	glutInitWindowSize (kWindowWidth, kWindowHeight);
	glutCreateWindow ("ANTZ");
	glutFullScreen();

	npInitGL(dataRef);

//	glutIgnoreKeyRepeat(1);		//ignore auto-repeat of keys
	glutKeyboardFunc(npGlutKeyDown);
	glutKeyboardUpFunc(npGlutKeyUp);
	glutSpecialFunc(npGlutKeyDownSpecial);
	glutSpecialUpFunc(npGlutKeyUpSpecial); 

	glutDisplayFunc(npGlutDrawGLScene);
	glutIdleFunc(npGlutDrawGLScene);

	glutReshapeFunc(npGLResizeScene);
}


//------------------------------------------------------------------------------
void npCloseGlut (void* dataRef)
{
}


//------------------------------------------------------------------------------
void npMainAppLoopGlut (void* data)
{
	glutMainLoop();
}


//------------------------------------------------------------------------------
void npGlutDrawGLScene(void) 
{
	npGLDrawScene (npDataGetDataRef());

	glutSwapBuffers();
}


//------------------------------------------------------------------------------
void npGlutFullScreenExit()
{
    glutPositionWindow (kWindowPositionX, kWindowPositionY);
	glutReshapeWindow (kWindowWidth, kWindowHeight);        /* Restore us */
}


//------------------------------------------------------------------------------
void npGlutKeyDown(unsigned char key, int x, int y) 
{
	npKeyGlut (key, x, y, kGlutKeyDown);
}

//------------------------------------------------------------------------------
void npGlutKeyUp(unsigned char key, int x, int y) 
{
	npKeyGlut (key, x, y, kGlutKeyUp);
}

//------------------------------------------------------------------------------
void npGlutKeyDownSpecial(int key, int x, int y) 
{
	npKeyGlut (key, x, y, kGlutKeyDownSpecial);
}

//------------------------------------------------------------------------------
void npGlutKeyUpSpecial(int key, int x, int y) 
{
	npKeyGlut (key, x, y, kGlutKeyUpSpecial);
}


//------------------------------------------------------------------------------
void npGLSolidSphere (GLdouble radius, GLint slices, GLint stacks)
{
	glutSolidSphere (radius, slices, stacks);
}

//------------------------------------------------------------------------------
void npGLWireSphere (GLdouble radius, GLint slices, GLint stacks)
{
	glutWireSphere (radius, slices, stacks);
}

//------------------------------------------------------------------------------
void npGLSolidCone (GLdouble base, GLdouble height, GLint slices, GLint stacks)
{
	glutSolidCone (base, height, slices, stacks);
}

//------------------------------------------------------------------------------
void npGLWireCone (GLdouble base, GLdouble height, GLint slices, GLint stacks)
{
	glutWireCone (base, height, slices, stacks);
}